"""
Authors: Christopher Re and Ben Recht
Copyright 2010-2011 Christopher Re and Ben Recht

This code is released under the GPLv3 License.
http://www.gnu.org/licenses/gpl.html

The files in this directory and its subdirectories are part of Jellyfish.

Jellyifsh is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Jellyfish is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jellyfish.  If not, see <http://www.gnu.org/licenses/>.
"""
import subprocess

#nr_list = [1000,10000,100000]
nr_list = [1000]
alpha_list = [1,5,10]
truerank_list = [5,10,20]
oversample_list = [3,5,10]
noise_var_dec_list = [2,3,4]
factor_type_list = [0]

output_base="output/out"

for nr in nr_list:
  for alpha in alpha_list:
    for truerank in truerank_list:
      for oversample in oversample_list:
        for noise_var_dec in noise_var_dec_list:
          for factor_type in factor_type_list:

            noise_var_print='0.'
    	    for k in range(noise_var_dec-1):
              noise_var_print += '0'
            noise_var_print+='1'

            extension = '.nr='+`nr`+'.alpha='+`alpha`+'.rrank='+`truerank`+\
                  '.beta='+`oversample`+'.sigma_squared='+noise_var_print+\
                  '.factor_type='+`factor_type`+'.data'

            out_file=output_base+extension
            f = open(out_file,"w")
            current_process = subprocess.Popen(["python","run_jellyfish.py",`nr`,`alpha`,`truerank`,`oversample`,`noise_var_dec`,`factor_type`],stdout=f)

            process_return_code = current_process.wait()

# AND THE JUMBO
# Uncomment the following lines to run the jumbo experiment
#nr = 1000000
#alpha = 1
#oversample = 5
#truerank = 10
#noise_var_dec = 3
#factor_type = 0
#noise_var_print='0.001'

#extension = '.nr='+`nr`+'.alpha='+`alpha`+'.rrank='+`truerank`+\
#             '.beta='+`oversample`+'.sigma_squared='+noise_var_print+\
#             '.factor_type='+`factor_type`+'.data'

#out_file=output_base+extension
#f = open(out_file,"w")
#current_process = subprocess.Popen(["python","run_jellyfish.py",`nr`,`alpha`,`truerank`,`oversample`,`noise_var_dec`,`factor_type`],stdout=f)

#process_return_code = current_process.wait()
