/* Authors: Christopher Re and Ben Recht
Copyright 2010-2011 Christopher Re and Ben Recht

This code is released under the GPLv3 License.
http://www.gnu.org/licenses/gpl.html

The files in this directory and its subdirectories are part of Jellyfish.

Jellyifsh is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Jellyfish is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jellyfish.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "test_handler.h"
#include "model.h"
#include "examples.h"

struct training_parameters {
  struct example* examples; // holds a pointer to the actual examples;
  int nExamples, nRows, nCols; // rows and columns to use (determined from the data load)

  int nShufflers;
  test_handler *t; // possibly null but allows us to test on a data
  int nEpochs; // Number of epochs to run for
  int max_rank; // maximum rank of the factors
  bool bTraceNorm; // if true trace norm, else max norm
  int nSplits; // Number of worker threads to use
  int seed; // the random seed
  // stepsize rules
  double initial_step_size, step_diminish; // for exponential rules C \rho^{k}
  double B, mu; // B is the constraint ball for max norm, mu is the general weight for trace norm.  
  bool bPrint; // should print out rmse etc
  struct model *initial_guess; // If NULL we rebuild the model.
};

struct model 
superfast_jellyfish(struct training_parameters tp);
