/* Authors: Christopher Re and Ben Recht
Copyright 2010-2011 Christopher Re and Ben Recht

This code is released under the GPLv3 License.
http://www.gnu.org/licenses/gpl.html

The files in this directory and its subdirectories are part of Jellyfish.

Jellyifsh is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Jellyfish is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jellyfish.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "examples.h"
#include <vector>
#include <iostream>
#include <fstream>

using namespace std;

struct example * 
load_examples(const char *szExample, int &nRows, int &nCols, int &nExamples) {
  vector<struct example> rets;
  ifstream f_in;
  int row,col;
  double rating;
  f_in.open(szExample, ios::in);
  nExamples = 0;
  int max_row = 0;
  int max_col = 0;
  
  while(!f_in.eof()) {
    row = -1; col = -1; rating = -1.0;
    f_in >> row >> col >> rating;
    example e;
    col--; row--; // correct the matlab code offsets
    VERBOSE_ONLY(cout << " ... " << col << " " << row << endl;);
    if(col < 0 && row < 0 && rating < 0) {
      continue;
    }
    if( col < 0 || row < 0 ) {
      cout << " ... " << row << " " << col << endl;
      assert(false);
    }
    e.row = row;
    e.col = col;
    e.rating = (double) rating;
    rets.push_back(e); 
    max_row = max(max_row, row);
    max_col = max(max_col, col);    
    nExamples++;
  }
  nRows = max_row + 1;
  nCols = max_col + 1;
  
  f_in.close();

  struct example *ret = new example[nExamples];
  for(int i =0; i< nExamples ; i++) {ret[i] = rets[i];}
  return ret;
}
