/* Authors: Christopher Re and Ben Recht
Copyright 2010-2011 Christopher Re and Ben Recht

This code is released under the GPLv3 License.
http://www.gnu.org/licenses/gpl.html

The files in this directory and its subdirectories are part of Jellyfish.

Jellyifsh is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Jellyfish is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jellyfish.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "frontend_util.h"
#include <string>
#include <iostream>
#include <iomanip>

using namespace std;

option*
convert_extended_options(const extended_option* exs)  {
  int nOptions = 0; 
  while(exs[nOptions++].name != NULL);
  struct option* opts =  new option[nOptions];
  for(int i = 0; i < nOptions; i++) {
    opts[i].name    = exs[i].name;
    opts[i].has_arg = exs[i].has_arg;
    opts[i].flag    = exs[i].flag;
    opts[i].val     = exs[i].val;
  }
  return opts;
}

void
print_usage(const extended_option *exs, char* sysname, char *usage_str) {
  string flags = "[";
  int i = 0;
  for(i=0;exs[i].name != NULL;i++) {
    string s = string("--") + string(exs[i].name);
    flags += (s + ((exs[i+1].name != NULL) ? string("|") : string("]")));
  }
  std::cout << "usage: " << sysname << " " << flags << " " << usage_str << std::endl;
   

  for(i=0;exs[i].name != NULL;i++) {
     string s = string("--") + string(exs[i].name);
     std::cout << "\t" << setw(20) << left << s  << "\t: " << exs[i].msg << std::endl;
   }
}
