/* Authors: Christopher Re and Ben Recht
Copyright 2010-2011 Christopher Re and Ben Recht

This code is released under the GPLv3 License.
http://www.gnu.org/licenses/gpl.html

The files in this directory and its subdirectories are part of Jellyfish.

Jellyifsh is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Jellyfish is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jellyfish.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <getopt.h>
// Extends the definition of option in getopt to add in a message.
struct extended_option
{
  const char *name;
  int has_arg,*flag,val;
  const char *msg;
};

// convert extended options to regular options for use in getopt.
option* convert_extended_options(const extended_option* exs);


// printout a usage string that lists all the options.
// extended options are all default options from above.
// sysname is typically argv[0]
// usage str contains the usage of the mandatory no flag options.
void print_usage(const extended_option *exs, char* sysname, char *usage_str);
