/* Authors: Christopher Re and Ben Recht
Copyright 2010-2011 Christopher Re and Ben Recht

This code is released under the GPLv3 License.
http://www.gnu.org/licenses/gpl.html

The files in this directory and its subdirectories are part of Jellyfish.

Jellyifsh is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Jellyfish is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jellyfish.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _MODEL_H__
#define _MODEL_H__
#include "fvector.h"
// This is our LR Model
struct model {
  int nRows, nCols;
  double moviemean;
  FVector *L, *R;
  model() { L = NULL; R = NULL; }
  model(int nr, int nc, double mm, FVector *_l, FVector *_r);
  ~model() {
    // if(L != NULL) { delete [] L; }
    // if(R != NULL) { delete [] R; } 
  }
};


// Testing and prediction code
double predict(struct model &m, int row, int col);
struct model *
build_model(int _nRows, int _nCols, double _moviemean,
	    FVector *l, FVector *r);
#endif
