/* Authors: Christopher Re and Ben Recht
Copyright 2010-2011 Christopher Re and Ben Recht

This code is released under the GPLv3 License.
http://www.gnu.org/licenses/gpl.html

The files in this directory and its subdirectories are part of Jellyfish.

Jellyifsh is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Jellyfish is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jellyfish.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "simple_random.h"
#include <cstdlib>
#include <iostream>
#include <cstdio>
void  
simple_random::gen_seed() {
  timeval _x;
  gettimeofday(&_x, NULL);
  (*(int*)_seed) = (unsigned int) (_x.tv_usec * _x.tv_sec );
}

void
simple_random::init() {
  DEBUG_ONLY(std::cout << "[simple_random] random seed initialized to " << _seed << std::endl;);
  seed48(_seed);
}

simple_random::simple_random() {
  _seed = new unsigned short[3];
  gen_seed();
  init();
}

simple_random::
simple_random(unsigned short *_s) {
  _seed = _s;
  if(_seed == NULL) { 
    _seed = new unsigned short[3];
    gen_seed(); 
  } 

  init();
}

int 
simple_random::rand_int(int nMax) {
  double sampledVal = erand48(_seed);
  return (int) (((double) nMax) * sampledVal);
}

double
simple_random::rand_double() { return drand48(); } 
