/* Authors: Christopher Re and Ben Recht
Copyright 2010-2011 Christopher Re and Ben Recht

This code is released under the GPLv3 License.
http://www.gnu.org/licenses/gpl.html

The files in this directory and its subdirectories are part of Jellyfish.

Jellyifsh is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Jellyfish is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jellyfish.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _test_handler_h__
#define _test_handler_h__ 1
#include "examples.h"
#include "model.h"

void*  rmse_run_thread(void *p);
class test_handler {
  int nTestExamples,nTests;
  struct example *_test;
  bool _should_free; // if we are passed a pointer, we do not free it.
public:
  test_handler(const char *szTestFile);
  test_handler(example *test, int nExamples);

  double test(struct model &m);
  double test_multithread(struct model &m, int nThreads);

  ~test_handler() { 
    if(_should_free && _test != NULL) { delete [] _test; } 
  }
  // friend functions for pthreads
  friend void* rmse_run_thread(void *p);
};
#endif
