/* Authors: Christopher Re and Ben Recht
Copyright 2010-2011 Christopher Re and Ben Recht

This code is released under the GPLv3 License.
http://www.gnu.org/licenses/gpl.html

The files in this directory and its subdirectories are part of Jellyfish.

Jellyifsh is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Jellyfish is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jellyfish.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <cstdlib>
#include "timer.h"

timer::timer(bool b) { if(b) {start();} }
timer::timer() { bStarted = false; } 
void timer::start() { bStarted = true; gettimeofday(&_start, NULL); } 
void timer::stop () { assert(bStarted); gettimeofday(&_stop, NULL); }
  // seconds
double timer::elapsed () { 
  struct timeval result; timersub(&_stop, &_start, &result); 
    return (double) result.tv_sec + (double) result.tv_usec * 1e-6; 
} 
double timer::stop_elapsed() {
  stop(); return elapsed();
}

std::ostream& operator<<(std::ostream &out, timer &t) {
  out << t.stop_elapsed() << "s" ;
  return out;
}
