/* Authors: Christopher Re and Ben Recht
Copyright 2010-2011 Christopher Re and Ben Recht

This code is released under the GPLv3 License.
http://www.gnu.org/licenses/gpl.html

The files in this directory and its subdirectories are part of Jellyfish.

Jellyifsh is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Jellyfish is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Jellyfish.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "global_macros.h"
#include <sys/time.h>
#include <iostream>

class timer {
  struct timeval _start, _stop;
  bool bStarted;
public:
  // don't start the timer
  timer();
  // automatically start the timer too
  timer(bool b);
  // start the timer
  void start(); 
  // stop the timer
  void stop ();
  // seconds
  double elapsed ();
  // stop and elapsed
  double stop_elapsed ();
  // elapsed
  double elapsed_minutes() { return elapsed()/60.0; } 
};

std::ostream& operator<<(std::ostream &out, timer &t);
